/*
Ŀ
 Demo program                                                                 
                                                                              
 The C User Interface Library                                                 
 Copyright 1993 Mathware, joneric Wennerstrom                                 

*/
#if defined(_QC) || defined(_MSC_VER) || defined(__POWERC) || defined(_ZTC_)
#include <direct.h>
#else
#include <dir.h>
#endif
#include <conio.h>
#include <dos.h>
#include <errno.h>
#include <io.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include "user_int.h"
/*
Ŀ
 Demo functions             

*/
void introduction(void);
void windows(void);
void menus(void);
void data_entry(void);
void mouse(void);
void errors(void);
void miscellaneous(MEN_PTR *men_ptr);
void date_functions(void);
void time_functions(void);
void network_functions(void);
void printer(void);
void files(void);
void print_line(void);
int  val_phone(void);
void show_capture(void);
void show_user(void);
void show_rights(WIN_PTR window,char rights);
void my_F2_function(int type,void *ptr,int indx,char *help_word);
void my_F3_function(int type,void *ptr,int indx,char *help_word);
void my_F7_function(int type,void *ptr,int indx,char *help_word);
void my_F9_function(int type,void *ptr,int indx,char *help_word);
WIN_PTR msg_box(char *msg);
/*
Ŀ
 C User Interface Demo                                                        

*/
void main(void)
{
int      sel;                          /* User's menu selection               */
MEN_PTR  men_ptr=0;                    /* Pointer to menu structure           */
MEN_ITEM men_items[8]={{0,1 ,"Windows"      ,".windows"      ,1},
                       {0,11,"Menus"        ,".menus"        ,1},
                       {0,19,"Data Entry"   ,".data_entry"   ,1},
                       {0,31,"Mouse"        ,".mouse"        ,1},
                       {0,39,"Errors"       ,".error"        ,1},
                       {0,48,"Miscellaneous",".miscellaneous",1},
                       {0,63,"Printer"      ,".printer"      ,1},
                       {0,71,"File"         ,".file"         ,1}};

w_init();                              /* Always the 1st line in any program  */
w_clrscrn();                           /* Clear the screen                    */
if (!w_mouse.installed)                /* Make the mouse menu item unselectabl*/
   men_items[3].sel=M_UNSELECTABLE;    /* if a mouse is not present           */
k_set(F2,my_F2_function);              /* Example of function key as a hot key*/
introduction();                        /* While running the demo, try pressing*/
                                       /* the F2 key at any time.             */
do
{
   sel=m_menu(2,2,1,76,w_color_menu,M_BOTH,M_BORDER,FALSE,M_OPEN,8,0,&men_ptr,men_items);
   switch(sel)                         /*                                     */
   {                                   /*                                     */
      case -1:                         /* User pressed ESC.                   */
           if ('Y'==w_ynbox("Do you wish to quit:",".quit"))
           {                           /*                                     */
                k_set(F2,0);           /* Release function hot key            */
                m_close(&men_ptr);     /* Close main menu                     */
                w_exit(0);             /* Restore initial screen              */
           }                           /*                                     */
      break;                           /*                                     */
      case 0:                          /*                                     */
           windows();                  /* Show user CUI window functions      */
      break;                           /*                                     */
      case 1:                          /*                                     */
           menus();                    /* Show user CUI menu functions        */
      break;                           /*                                     */
      case 2:                          /*                                     */
           data_entry();               /* Show user CUI data entry functions  */
      break;                           /*                                     */
      case 3:                          /*                                     */
           mouse();                    /* Show user CUI mouse functions       */
      break;                           /*                                     */
      case 4:                          /*                                     */
           errors();                   /* Show user CUI custom error handling */
      break;                           /* functions                           */
      case 5:                          /*                                     */
           miscellaneous(&men_ptr);    /* Show user CUI setup, time, date,    */
      break;                           /* hardware, and network functions     */
      case 6:                          /*                                     */
           printer();                  /* Show user CUI printer functions     */
      break;                           /*                                     */
      case 7:                          /*                                     */
           files();                    /* Show user CUI file functions        */
      break;                           /*                                     */
   }                                   /*                                     */
}  while(TRUE);                        /*                                     */
}
/*
Ŀ
 introduction() - Display opening screen                                      

*/
void introduction(void)
{
WIN_PTR  window;                       /* Introduction window                 */
#if defined(__POWERC)
char *title="Mix Power C Demo";
#elif defined(__TURBOC__)
char *title="Borland C Demo";
#elif defined(_QC)
char *title="Quick C Demo";
#elif defined(_MSC_VER)
char *title="Microsoft C Demo";
#elif defined(_ZTC_)
char *title="Zortech C Demo";
#endif

window=w_open(2,5,19,70,W_BORDER,w_shadows,w_color_data,title);
v_setcolor(F_BLACK+B_GREY);
w_prtf(window,"\n                     The C User Interface Library\n\n");
w_prtf(window,"                    copyright (c) 1993 by Mathware\n\n");
v_setcolor(w_color_data.standard);
w_prtf(window,"    This is a  sample  program  written using  the C  User  Interface\n");
w_prtf(window," Library.  It demonstrates nearly every  function available.  Use the\n");
w_prtf(window," prt_man program  in the utility directory to  print out the manuual.\n");
w_prtf(window," You may try out this software for a trial period of 40 days.  At the\n");
w_prtf(window," end of that period, you  must either stop using the  software or you\n");
w_prtf(window," must register with Mathware.  A registration form is included in the\n");
w_prtf(window," documentation directory.  Upon registering, you will recieve:\n\n");
v_setcolor(F_WHITE+B_GREY);
w_prtf(window," 1. All 5 memory models of the library with file edit feature enabled.\n");
w_prtf(window," 2. Single user license.\n");
w_prtf(window," 3. Technical support.\n");
w_prtf(window," 4. Printer database format to allow you to add unsupported printers.\n");
w_prtf(window," 5. Update notices and discounts to new releases.\n");
k_wait(0);
w_close(window);
v_setcolor(w_color_data.standard);
}
/*
Ŀ
 windows() - Window functions                                                 

*/
void windows(void)
{
unsigned int key;
WIN_PTR  window0,
         window1;
int sel,sub_sel;
MEN_PTR  win_men_ptr=0;
MEN_ITEM win_men_items[4]={{0,0,"Borders",".borders"      ,1},
                           {1,0,"Shadows",".shadows"      ,1},
                           {2,0,"Titles ",".titles"       ,1},
                           {3,0,"Scroll ",".scroll_window",1}};
MEN_PTR  brd_men_ptr=0;
MEN_ITEM brd_men_items[5]={{0,0,"None            ",".no_brd"     ,1},
                           {1,0,"Single          ",".single_line",1},
                           {2,0,"Double          ",".double_line",1},
                           {3,0,"Single Drop Down",".single_drop",1},
                           {4,0,"Double Drop Down",".double_drop",1}};


do
{
   sel=m_menu(6,3,4,7,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,4,0,&win_men_ptr,
              win_men_items);
   switch(sel)
   {
      case 0:
           do
           {
              window0=msg_box("There are 5 types of possible window borders.");
              sub_sel=m_menu(8,9,5,16,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,
                             5,0,&brd_men_ptr,brd_men_items);
              w_close(window0);
              switch(sub_sel)
              {
                 case 0:
                      window1=w_open(9,30,9,46,FALSE,w_shadows,w_color_data,0);
                      k_wait(0);
                      w_close(window1);
                 break;
                 case 1:
                      w_setborder(SINGLE_LINE);
                      window1=w_open(9,30,9,46,TRUE,w_shadows,w_color_data,0);
                      k_wait(0);
                      w_close(window1);
                      w_setborder(SINGLE_LINE);
                 break;
                 case 2:
                      w_setborder(DOUBLE_LINE);
                      window1=w_open(9,30,9,46,TRUE,w_shadows,w_color_data,0);
                      k_wait(0);
                      w_close(window1);
                      w_setborder(SINGLE_LINE);
                 break;
                 case 3:
                      w_setborder(SINGLE_DROP);
                      window1=w_open(9,30,9,46,TRUE,w_shadows,w_color_data,0);
                      k_wait(0);
                      w_close(window1);
                      w_setborder(SINGLE_LINE);
                 break;
                 case 4:
                      w_setborder(DOUBLE_DROP);
                      window1=w_open(9,30,9,46,TRUE,w_shadows,w_color_data,0);
                      k_wait(0);
                      w_close(window1);
                      w_setborder(SINGLE_LINE);
                 break;
              }
           } while(sub_sel!=-1);
           m_close(&brd_men_ptr);
      break;
      case 1:
           window0=msg_box("Windows can have shadows.  Use setup to turn shadows On/Off.");
           if (!window0) return;
           window1=w_open(9,30,9,46,1,w_shadows,w_color_data,w_shadows?"Shadows":"No Shadows");
           if (!window1) return;
           k_wait(0);
           w_close(window1);
           w_close(window0);
      break;
      case 2:
           window0=msg_box("Optional Titles appear on the top and are centered.");
           if (!window0) return;
           window1=w_open(9,30,9,46,1,1,w_color_data,"Example Title");
           if (!window1) return;
           k_wait(0);
           w_close(window1);
           w_close(window0);
      break;
      case 3:
           window0=msg_box("Use the arrow keys to scroll the contents of the window.");
           if (!window0) return;
           window1=w_open(9,30,9,46,1,1,w_color_data,"Scrolling Windows");
           if (!window1) return;

           w_prtf(window1,"%s","\n This is a test of the w_prtf() function.\n\n");
           w_prtf(window1," Int: %d     Float:  %f      Char: %c\n",22,-4.65,'D');
           w_prtf(window1,"%s"," Hello world!\n");
           do
           {
              key=k_getkey();
              switch(key)
              {
                 case UP_ARROW:
                 case CTRL_UP_ARROW:
                      w_vscroll(window1,UP,1);
                 break;
                 case DN_ARROW:
                 case CTRL_DN_ARROW:
                      w_vscroll(window1,DOWN,1);
                 break;
                 case RT_ARROW:
                 case CTRL_RT_ARROW:
                      w_hscroll(window1,RIGHT,1);
                 break;
                 case LT_ARROW:
                 case CTRL_LT_ARROW:
                      w_hscroll(window1,LEFT,1);
                 break;
              }
           }  while(key!=ESC);
           w_close(window1);
           w_close(window0);
      break;
      case -1:                         /* User pressed right\left arrow key,  */
           if (w_lastkey!=ESC)         /* or Escape                           */
           {                           /* If it's an arrow key, move to next  */
              k_putkey(w_lastkey);     /* next item in main menu and open it's*/
              k_putkey(ENTER);         /* drop down menu.                     */
           }
      break;
   }
} while(sel!=-1);
m_close(&win_men_ptr);
}
/*
Ŀ
 menus() - Menu functions                                                     

*/
void menus(void)
{
int       sel,                         /* Menu selection                      */
          sub_sel,                     /* Sub-menu selection                  */
          i,                           /* Loop variable                       */
          num_items;                   /* Number of items in scroll type menus*/
WIN_PTR   window,                      /* Message box window                  */
          scrl_window;                 /* Window for scroll menu              */
ATTRIBUTE lotus1_color={7,14},         /* Colors for Lotus style menu example */
          lotus2_color={14,112};
MEN_PTR  men_ptr=0;                    /* Menu types                          */
MEN_ITEM men_items[6]={{0,0,"Horizontal",".horizontal" ,1},
                       {1,0,"Vertical  ",".vertical"   ,1},
                       {2,0,"Lotus     ",".lotus"      ,1},
                       {3,0,"Scrolling ",".scroll_menu",1},
                       {4,0,"List Box  ",".list_box"   ,1},
                       {5,0,"File Box  ",".file_box"   ,1}};
MEN_PTR  ver_men_ptr=0;
MEN_ITEM ver_men_items[7]={{0,0,"New File  F9 ",".item1",1},
                           {1,0,"Open      F7 ",".item2",1},
                           {2,0, M_LINE        ,".none" ,0},
                           {3,0,"Save      F3 ",".item3",1},
                           {4,0,"Save As.. F2 ",".item4",1},
                           {5,0, M_LINE        ,       0,0},
                           {6,0,"Exit to DOS  ",".item5",1}};
MEN_PTR  hor_men_ptr=0;
MEN_ITEM hor_men_items[4]={{0, 1,"Item1",".item1",1},
                           {0,10,"Item2",".item2",1},
                           {0,19,"Item3",".item3",1},
                           {0,28,"Item4",".item4",1}};
char items[37][13]={{"item1.txt"}, {"item2.txt"}, {"item3.txt"}, {"item4.txt"},
                    {"item5.txt"}, {"item6.txt"}, {"item7.txt"}, {"item8.txt"},
                    {"item9.txt"}, {"item10.txt"},{"item11.txt"},{"item12.txt"},
                    {"item13.txt"},{"item14.txt"},{"item15.txt"},{"item16.txt"},
                    {"item17.txt"},{"item18.txt"},{"item19.txt"},{"item20.txt"},
                    {"item21.txt"},{"item22.txt"},{"item23.txt"},{"item24.txt"},
                    {"item25.txt"},{"item26.txt"},{"item27.txt"},{"item28.txt"},
                    {"item29.txt"},{"item30.txt"},{"item31.txt"},{"item32.txt"},
                    {"item33.txt"},{"item34.txt"},{"item35.txt"},{"item36.txt"},
                    {"item37.txt"}},
    *items_ptr[37],                    /* Pointer array for scroll menu exampl*/
     selected[37],                     /* Array for list box menu             */
     dir[128],                         /* Directory to use for file box exampl*/
     sel_file[14],                     /* Name of file selected in file box ex*/
     msg[80];                          /* Buffer used to display messages     */

for (i=0;i<37;++i)
{
     items_ptr[i]=items[i];            /* Get array of pointer to scroll items*/
     selected[i]=0;                    /* Set all selected[] to 0 so that they*/
}                                      /* are unselected                      */
do
{
   sel=m_menu(6,13,6,10,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,6,0,&men_ptr,
              men_items);
   switch(sel)
   {
      case 0:
           window=msg_box("Use the Left/Right arrow keys to move around.  Esc to quit, Enter to select");
           if (!window) return;
           sub_sel=m_menu(6,30,1,34,w_color_menu,M_HORZ,M_BORDER,w_shadows,M_CLOSE,4,
                          0,&hor_men_ptr,hor_men_items);
           w_close(window);
           switch (sub_sel)
           {
              case -1:
                    if (w_lastkey==ESC)
                        window=msg_box("You pressed Escape.  Esc quits the menu.");
                    else
                       window=msg_box("You pressed an Up/Dn arrow.  In HORZ menus, this also quits the menu.");
                    if (!window) return;
                    k_wait(0);
                    w_close(window);
              break;
              default:
                    sprintf(msg,"You selected item %1d.",sub_sel+1);
                    window=msg_box(msg);
                    if (!window) return;
                    k_wait(0);
                    w_close(window);
              break;
           }
      break;
      case 1:
           window=msg_box("Use the Up/Down arrow keys to move around.  Esc to quit, Enter to select");
           if (!window) return;
           k_set(F3,my_F3_function);   /* Ex of function key as a hot key     */
           k_set(F7,my_F7_function);   /* Ex of function key as a hot key     */
           k_set(F9,my_F9_function);   /* Ex of function key as a hot key     */
           sub_sel=m_menu(6,35,7,13,w_color_menu,M_VERT,M_BORDER,w_shadows,M_CLOSE,7,
                          0,&ver_men_ptr,ver_men_items);
           w_close(window);
           switch (sub_sel)
           {
              case -1:
                    if (w_lastkey==ESC)
                        window=msg_box("You pressed Escape.  Esc quits the menu.");
                    else
                        window=msg_box("You pressed an Lt/Rt arrow.  In VERT menus, this also quits the menu.");
                    if (!window) return;
                    k_wait(0);
                    w_close(window);
              break;
              default:
                    sprintf(msg,"You selected item %1d.",sub_sel+1);
                    window=msg_box(msg);
                    if (!window) return;
                    k_wait(0);
                    w_close(window);
              break;
           }
           k_set(F3,0);                /* Reset function keys so that they are*/
           k_set(F7,0);                /* no longer hot keys                  */
           k_set(F9,0);
      break;
      case 2:
           do
           {
               sub_sel=m_menu(7,32,1,33,lotus1_color,M_HORZ,M_NO_BORDER,FALSE,M_OPEN,
                              4,0,&hor_men_ptr,hor_men_items);
               w_setborder(DOUBLE_LINE);
               switch (sub_sel)
               {
                  case 0:
                       m_menu(9,34,7,13,lotus2_color,M_VERT,M_BORDER,w_shadows,
                              M_CLOSE,7,0,&ver_men_ptr,ver_men_items);
                  break;
                  case 1:
                       m_menu(9,43,7,13,lotus2_color,M_VERT,M_BORDER,w_shadows,
                              M_CLOSE,7,0,&ver_men_ptr,ver_men_items);
                  break;
                  case 2:
                       m_menu(9,52,7,13,lotus2_color,M_VERT,M_BORDER,w_shadows,
                              M_CLOSE,7,0,&ver_men_ptr,ver_men_items);
                  break;
                  case 3:
                       m_menu(9,61,7,13,lotus2_color,M_VERT,M_BORDER,w_shadows,
                              M_CLOSE,7,0,&ver_men_ptr,ver_men_items);
                  break;
               }
               w_setborder(SINGLE_LINE);
                                       /* Move over to next drop down menu and*/
               if (w_lastkey==LT_ARROW || w_lastkey==RT_ARROW)
               {                       /* open it up                          */
                  k_putkey(w_lastkey);
                  k_putkey(ENTER);
               }
           }   while(sub_sel!=-1);
           m_close(&hor_men_ptr);
      break;
      case 3:                          /* General Scroll menu                 */
           window=msg_box("Use the arrow keys, Home, End, Page Up/DN to move around inside the menu.");
           if (!window) return;
           sub_sel=m_scrollmenu(7,33,5,3,w_color_menu,&scrl_window,36,12,
                   items_ptr,w_shadows,"Scroll Menu",".scroll_menu");
           w_close(scrl_window);       /* Close scroll menu window            */
           w_close(window);            /* Close help message window at bottom */
           if (sub_sel==-1)
               window=msg_box("You pressed Escape.  Esc quits the menu.");
           else
           {
               sprintf(msg,"You selected item %1d.",sub_sel+1);
               window=msg_box(msg);
           }
           if (!window) return;
           k_wait(0);
           w_close(window);
      break;
      case 4:                          /* List box                            */
           window=msg_box("Use the space bar to toggle an item, Enter to finalize selections.");
           if (!window) return;
           sub_sel=m_listbox(7,33,5,3,w_color_menu,&scrl_window,36,12,items_ptr,
                   w_shadows,"List box",".list_box",selected);
           w_close(scrl_window);       /* Close list box menu window          */
           w_close(window);            /* Close help message window at bottom */
           if (sub_sel==-1)
           {
               sprintf(msg,"You pressed Esc.  Esc quits the list box.");
               window=msg_box(msg);
               k_wait(0);
               w_close(window);
           }
           else
           {
               num_items=0;            /* Find out the total number of items  */
               for(i=0;i<36;++i)       /* selected.                           */
                   if (selected[i]) ++num_items;
               sprintf(msg,"You selected %d items.",num_items);
               window=msg_box(msg);
               k_wait(0);
               w_close(window);
               for(i=0;i<36;++i)
                   if (selected[i])
                   {
                       sprintf(msg,"You selected item %d.",i+1);
                       window=msg_box(msg);
                       k_wait(0);
                       w_close(window);
                   }
           }
      break;
      case 5:                          /* File box                            */
           window=msg_box("This is a list of files in the current directory. Press Enter to select one.");
           dir[0]=0;                   /* Use current directory               */
           sub_sel=m_filebox(7,33,5,3,w_color_menu,&scrl_window,w_shadows,"File box",
                   ".file_box",dir,"*.*",FA_DIREC | FA_ARCH,sel_file);
           w_close(window);            /* Close help message window           */
           switch (sub_sel)
           {
              case -2:
                   sprintf(msg,"Error: Insufficient memory or no files available.");
              break;
              case -1:
                   sprintf(msg,"You pressed Escape.  Esc quits the menu.");
              break;
              default:
                   sprintf(msg,"You selected item %d - %s",sub_sel+1,sel_file);
              break;
           }
           window=msg_box(msg);        /* Display message                     */
           k_wait(0);                   /* Wait for user to view message       */
           w_close(window);            /* Close message window                */
           w_close(scrl_window);       /* Close file box menu window          */
      break;
      case -1:
           if (w_lastkey!=ESC)
           {
              k_putkey(w_lastkey);
              k_putkey(ENTER);
           }
      break;
   }
} while(sel!=-1);
m_close(&men_ptr);
}
/*
Ŀ
 data_entry() - Data Entry functions                                          

*/
void data_entry(void)
{
WIN_PTR         window0,               /* Message window                      */
                window1;               /* Data entry window                   */
static char     char_val=127;          /* Data entry variables                */
static unsigned char unchar_val=255;
static int      int_val=32767;
static unsigned int unint_val=65535U;
static long     long_val=2147483647L;
static unsigned long unlong_val=7295U;
static float    float_val=3.4E38;
static double   double_val=1.7E308;
static char     string[56]={"Mathware"},
                phone[15],
                password[16],
                filename[76],
                check[3],
                yn,
                tf,
                soc_sec[12]={"082-62-6821"},
                zip[6]={"11758"},
                ext_zip[11]={"24122-9801"};
static W_DATE   date={12,04,91},
                ext_date={12,04,1991};
static W_TIME   time={10,15,00,'p'},
                ext_time={10,15,00,'p'};

window0=msg_box("The C User Interface Library comes with many built-in data types.");
if (!window0) return;                  /* Display our little message          */
k_wait(0);                             /* Then close it so user can get on    */
w_close(window0);                      /* with his life already!              */
window1=w_open(7,2,15,76,1,0,w_color_data,"Data Entry");
if (!window1){w_close(window0);return;}/* Use default valids except for phone */
g_char    (window1, 0, 1,"Char....:",&char_val,     TRUE ,0,0);
g_unchar  (window1, 0,33,"Un Char.:",&unchar_val,   TRUE ,0,0);
g_string  (window1, 1, 1,"String..:",string,     55,TRUE ,".g_string",0);
g_int     (window1, 2, 1,"Integer.:",&int_val,    6,TRUE ,".g_int",0);
g_unint   (window1, 2,33,"Un Int..:",&unint_val,  5,TRUE ,".g_un_int",0);
g_long    (window1, 3, 1,"Long....:",&long_val,  11,TRUE ,".g_long_int",0);
g_unlong  (window1, 3,33,"Un Long.:",&unlong_val,10,TRUE ,".g_un_long_int",0);
g_float   (window1, 4, 1,"Float...:",&float_val, 13,TRUE ,".g_float",0);
g_double  (window1, 4,33,"Double..:",&double_val,24,TRUE ,".g_double",0);
g_date    (window1, 5, 1,"Date....:",&date,         TRUE ,".g_date",0);
g_ext_date(window1, 5,33,"Ext Date:",&ext_date,     TRUE ,".g_ext_date",0);
g_time    (window1, 6, 1,"Time....:",&time,         TRUE ,".g_time",0);
g_ext_time(window1, 6,33,"Ext Time:",&ext_time,     TRUE ,".g_ext_time",0);
g_zip     (window1, 7, 1,"Zip.....:",zip,           TRUE ,".g_zip",0);
g_ext_zip (window1, 7,33,"Ext Zip.:",ext_zip,       TRUE ,".g_ext_zip",0);
g_yn      (window1, 8, 1,"Yes/No..:",&yn,           TRUE ,".g_yn",0);
g_tf      (window1, 8,33,"True/Fal:",&tf,           TRUE ,".g_tf",0);
g_phone   (window1, 9, 1,"Phone #.:",phone,         FALSE,".g_phone",val_phone);
g_soc_sec (window1, 9,33,"Soc Sec.:",soc_sec,       TRUE ,".g_soc_sec",0);
g_password(window1,10, 1,"Password:",password,   15      ,".g_password",0);
g_filename(window1,11, 1,"Filename:",filename,   75,FALSE,".g_filename",0);
g_checkbox(window1,12, 1,"Item 1"   ,&check[0],     FALSE,0,0);
g_checkbox(window1,13, 1,"Item 2"   ,&check[1],     FALSE,0,0);
g_checkbox(window1,14, 1,"Item 3"   ,&check[2],     FALSE,0,0);
g_read();
g_close();
w_close(window1);
}
/*
Ŀ
 my_F2_function() - F2 hot key function executed whenever F2 is pressed       

*/
void my_F2_function(int type,void *ptr,int indx,char *help_word)
{
char *fun_type[5]={"Menu","Read","Wait","Scroll","File Edit"};
                                       /* An example of what information is   */
                                       /* passed to a function key routine    */
switch (type)                          /* when a function key is set as a hot */
{                                      /* key.                                */
   case K_MENU:                        /* Pressed while in a hor\ver menu     */
        w_errbox(0,"In F2 function. Type: %s  ptr: %p  Item: %d   Help: %s",
                 fun_type[type],ptr,indx,help_word);
   break;
   case K_READ:                        /* Pressed while doing data entry (get)*/
        w_errbox(0,"In F2 function. Type: %s  ptr: %p  Get: %d   Help: %s",
                 fun_type[type],ptr,indx,help_word);
   break;
   case K_WAIT:                        /* Pressed while in k_wait()           */
        w_errbox(0,"In F2 function. Type: %s  ptr: %p  Index: %d   Help: %s",
                 fun_type[type],ptr,indx,help_word);
   break;                              /* Pressed while in scroll menu,file or*/
   case K_SCRL:                        /* list box                            */
        w_errbox(0,"In F2 function. Type: %s  ptr: %p  Item: %d   Help: %s",
                 fun_type[type],ptr,indx,help_word);
   break;
   case K_EDIT:                        /* Pressed while editing a file        */
        w_errbox(0,"In F2 function. Type: %s  ptr: %p  Row: %d   Help: %s",
                 fun_type[type],ptr,indx,help_word);
   break;
}
}
/*
Ŀ
 my_F3_function() - F3 hot key function executed whenever F3 is pressed       

*/
void my_F3_function(int type,void *ptr,int indx,char *help_word)
{
w_errbox(0,"In F3 function.");
}
/*
Ŀ
 my_F7_function() - F8 hot key function executed whenever F8 is pressed       

*/
void my_F7_function(int type,void *ptr,int indx,char *help_word)
{
w_errbox(0,"In F7 function.");
}
/*
Ŀ
 my_F9_function() - F9 hot key function executed whenever F9 is pressed       

*/
void my_F9_function(int type,void *ptr,int indx,char *help_word)
{
w_errbox(0,"In F9 function.");
}
/*
Ŀ
 phone valid function                                                         

*/
int val_phone(void)
{
int      sel;                          /* Menu selection from phone list      */
char     *phone;                       /* Address of phone var being edited   */
WIN_PTR  window;                       /* Window to display phone menu message*/
MEN_PTR  phone_men_ptr=0;              /*                                     */
MEN_ITEM phone_men_items[5]={{0,0,"Tia     (212) 936-4240",".v_phone",1},
                             {1,0,"Uwe     (718) 423-4804",".v_phone",1},
                             {2,0,"Monika  (516) 541-6410",".v_phone",1},
                             {3,0,"Sabine  (716) 931-3113",".v_phone",1},
                             {4,0,"Jorg    (804) 947-0110",".v_phone",1}};
if (!def_val_phone())                  /* Execute the default valid phone fun */
    return(FALSE);                     /* (Make sure user entered a phone #)  */
if (w_lastkey!=DN_ARROW) return(TRUE); /* If we got to here, then the user    */
                                       /* entered a valid phone number(because*/
                                       /* we executed the default phone valid */
                                       /* and it passed.                      */
                                       /* So, if the user is finished,(if the */
                                       /* PG_DN key was pressed, then don't   */
                                       /* display the phone picklist          */
phone=w_get.get[w_get.cur_get]->edit_var;/*Get ptr to phone var being edited  */
window=msg_box("You may also choose from this list of phone numbers.");
sel=m_menu(12,36,5,22,w_color_menu,M_BOTH,M_BORDER,w_shadows,M_CLOSE,5,0,
           &phone_men_ptr,phone_men_items);
if (sel!=-1)                           /* If user press did not press ESC,    */
                                       /* Copy the phone number from the menu */
                                       /* into the data entry field by using  */
                                       /* s_strsub to get only the #, not the */
                                       /* name.                               */
    strcpy(phone,s_strsub(phone_men_items[sel].text,8,15));
w_close(window);                       /* Close the help msg at bottom of scrn*/
return(def_val_phone());               /* Now, call the default phone valid   */
                                       /* Function to make sure that the phone*/
                                       /* number really is ok.                */
}
/*
Ŀ
 mouse() - Mouse Functions                                                    

*/
void mouse(void)
{
WIN_PTR window;                        /* Window to show mouse location\status*/
int     old_mous_cur=w_mouse.cursor,
        button,
        key;

window=w_open(6,23,7+w_mouse.num_buttons,25,TRUE,w_shadows,w_color_data,"Mouse");
m_getcur();                            /* Print headings and initial values   */
w_prtf(window,"      Pixel  Text\n");  /*                                     */
w_prtf(window,"        \n");  /*                                     */
w_prtf(window," row: %3d   %3d\n",w_mouse.pix_row,w_mouse.txt_row);
w_prtf(window," col: %3d   %3d\n\n",w_mouse.pix_col,w_mouse.txt_col);
w_prtf(window,"      Buttons\n");      /*                                     */
w_prtf(window,"      \n");      /*                                     */
w_prtf(window,"lft:  0\n");            /*                                     */
w_prtf(window,"rht:  0");              /*                                     */
if (w_mouse.num_buttons==3) w_prtf(window,"\ncen:  0");
if (!w_mouse.cursor) m_curon();        /*                                     */

while(!kbhit())                        /* Wait till user presses a key to quit*/
{                                      /* mouse demo                          */

  if (m_motion())                      /* If user moved mouse, show new screen*/
  {                                    /* position                            */
     m_getcur();                       /*                                     */
     w_setcur(window,2,6);             /*                                     */
     w_prtf(window,"%3d   %3d\n",w_mouse.pix_row,w_mouse.txt_row);
     w_setcur(window,3,6);             /*                                     */
     w_prtf(window,"%3d   %3d",w_mouse.pix_col,w_mouse.txt_col);
  }
                                       /* If user pressed a mouse button, show*/
  if (m_getpress(M_LEFT)   || m_getpress(M_RIGHT)   || m_getpress(M_CENTER)
  ||  m_getrelease(M_LEFT) || m_getrelease(M_RIGHT) || m_getrelease(M_CENTER))
  {                                    /* which one                           */
      m_button();                      /* Get which mouse button was pressed  */
      for (button=M_LEFT;button<=M_CENTER;++button)
      {                                /* Display each button status          */
           w_setcur(window,7+button,6);/* on a different row                  */
           switch (button)             /*                                     */
           {                           /*                                     */
              case M_LEFT:             /*                                     */
                   w_prtf(window,"%d",w_mouse.lft_but);
              break;                   /*                                     */
              case M_RIGHT:            /*                                     */
                   w_prtf(window,"%d",w_mouse.rht_but);
              break;                   /*                                     */
              case M_CENTER:           /*                                     */
                   if (w_mouse.num_buttons==3) w_prtf(window,"%d",w_mouse.cnt_but);
              break;                   /*                                     */
           }                           /*                                     */
      }                                /*                                     */
      m_debounce();                    /* Wait till mouse press\release settle*/

      for (button=M_LEFT;button<=M_CENTER;++button)
      {                                /* Check if the button press is a      */
           w_setcur(window,7+button,15);/*double click                        */
           switch (button)             /*                                     */
           {                           /*                                     */
              case M_LEFT:             /* need to report center button press  */
                   if (w_mouse.lft_but && m_double(M_LEFT))
                       w_prtf(window,"Double");
                   else                /*                                     */
                      w_prtf(window,"      ");
              break;                   /*                                     */
              case M_RIGHT:            /*                                     */
                   if (w_mouse.rht_but && m_double(M_RIGHT))
                       w_prtf(window,"Double");
                   else                /*                                     */
                      w_prtf(window,"      ");
              break;                   /*                                     */
              case M_CENTER:           /*                                     */
                     if (w_mouse.cnt_but && m_double(M_CENTER))
                       w_prtf(window,"Double");
                   else                /*                                     */
                      w_prtf(window,"      ");
              break;                   /*                                     */
           }                           /*                                     */
      }                                /*                                     */
      w_setcur(window,0,1);            /*                                     */
  }                                    /*                                     */
};                                     /*                                     */
key=k_getkey();                        /* Remove key from keyboard            */

w_close(window);                       /* Clear mouse display window          */
if (!old_mous_cur) m_curoff();         /* Restore mouse cursor status         */
if (key==RT_ARROW || key==LT_ARROW)    /* If user pressed a left or right     */
{                                      /* arrow key, move over in the parent  */
   k_putkey(key);                      /* menu                                */
   k_putkey(ENTER);                    /*                                     */
}                                      /*                                     */
}                                      /*                                     */
/*
Ŀ
 errors() - Error Handler functions                                           

*/
void errors(void)
{
int      sel,                          /* Error menu selection                */
         dsk_sel,                      /* Disk error menu selection           */
         mth_sel;                      /* Math error menu selection           */
double   num=0.0;
char file[76]={"A:\\test.txt"};
double   fp_err;
WIN_PTR  window;
MEN_PTR  err_men_ptr=0;
MEN_ITEM err_men_items[3]={{0,0,"Disk  ",".disk_err",1},
                           {1,0,"Math  ",".math_err",1},
                           {2,0,"Ctrl C",".ctrl_c"  ,1}};
MEN_PTR  dsk_men_ptr=0;
MEN_ITEM dsk_men_items[2]={{0,0,"Read ",".dsk_read" ,1},
                           {1,0,"Write",".dsk_write",1}};

MEN_PTR  mth_men_ptr=0;
MEN_ITEM mth_men_items[3]={{0,0,"Domain       ",".sqr__1"     ,1},
                           {1,0,"Overflow     ",".overflow"   ,1},
                           {2,0,"Singularity  ",".singularity",1}};

do
{
   sel=m_menu(6,42,3,6,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,3,0,&err_men_ptr,
              err_men_items);
   switch(sel)
   {
      case -1:                         /* User pressed a let\right arrow or   */
           if (w_lastkey!=ESC)         /* Escape                              */
           {                           /* If it was an arrow key, move over in*/
              k_putkey(w_lastkey);     /* the parent menu                     */
              k_putkey(ENTER);         /*                                     */
           }                           /*                                     */
      break;                           /*                                     */
      case 0:                          /* Disk Drive errors                   */
           do                          /*                                     */
           {                           /*                                     */
              if (!w_num_floppies)     /* Only allow user to choose this if he*/
              {                        /* has a floppy drive                  */
                  w_errbox(0,"There are no floppy drives available to test disk errors.");
                  break;               /*                                     */
              }                        /*                                     */
              w_ERROR=FALSE;           /*                                     */
              dsk_sel=m_menu(8,48,2,5,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,2,
                             0,&dsk_men_ptr,dsk_men_items);
              switch(dsk_sel)          /*                                     */
              {                        /*                                     */
                 case 0:               /*                                     */
                      window=msg_box("Open the door to drive A.  Then press ENTER.");
                      if (!window) break;

                      if (k_getkey()==ENTER)
                         fopen(file,"rt");
                      w_close(window);
                 break;
                 case 1:
                      window=msg_box("Place a write protected disk in drive A.  Then press ENTER.");
                      if (!window) break;
                      if (k_getkey()==ENTER)
                         fopen(file,"wt");
                      w_close(window);
                 break;
              }
           }  while(dsk_sel!=-1);
           if (w_num_floppies)         /* This menu is opened only if floppy  */
               m_close(&dsk_men_ptr);  /* drive(s) are detected               */
      break;
      case 1:                          /* Math errors                         */
           do
           {
              w_ERROR=FALSE;
              mth_sel=m_menu(8,47,3,13,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,
                             3,0,&mth_men_ptr,mth_men_items);
              switch(mth_sel)
              {
                 case 0:
                      fp_err=sqrt(-1);
                 break;
                 case 1:
                      fp_err=exp(2000);
                 break;
                 case 2:
                      fp_err=log(-1);
                 break;
              }
           } while(mth_sel!=-1);
           m_close(&mth_men_ptr);
      break;
      case 2:                          /* Ctrl-C\Break errors                 */
           window=msg_box("The Ctrl-C\\Break keys have been disabled. Try it. Press ESC when your done.");
           while(k_getkey()!=ESC);
           w_close(window);
      break;
   }
} while(sel!=-1);
m_close(&err_men_ptr);
}
/*
Ŀ
 Miscellaneous() - Show various unrelated features of the library.            

*/
void miscellaneous(MEN_PTR *men_ptr)
{
int      sel;                          /* Miscellaneous menu choice           */
MEN_PTR  misc_menu_ptr=0;              /*                                     */
MEN_ITEM misc_menu_items[5]={{0,0,"Setup   ",".w_setup" ,1},
                             {1,0,"Hardware",".hardware",1},
                             {2,0,"Date    ",".date"    ,1},
                             {3,0,"Time    ",".time"    ,1},
                             {4,0,"Network ",".network" ,0}};

if (w_network.installed) misc_menu_items[4].sel=TRUE;

do
{
    sel=m_menu(6,51,5,8,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,5,0,
               &misc_menu_ptr,misc_menu_items);
    switch (sel)
    {
       case -1:                        /* User pressed a let\right arrow or   */
            if (w_lastkey!=ESC)        /* Escape                              */
            {                          /* If it was an arrow key, move over in*/
               k_putkey(w_lastkey);    /* the parent menu                     */
               k_putkey(ENTER);        /*                                     */
            }                          /*                                     */
       break;                          /*                                     */
       case 0:                         /* Setup                               */
            m_close(&misc_menu_ptr);
            m_close(men_ptr);          /* Stuff keys so that we return to the */
            w_setup();                 /* misc setup. Number of rt arrow keys */
            for(sel=0;sel<4+(w_mouse.installed!=FALSE);++sel)     /* depends on if mouse is*/
                k_putkey(RT_ARROW);    /* installed.  Otherwise, a mouse menu */
            k_putkey(ENTER);           /* is not selectable and we'll move too*/
            sel=-1;                    /* far in the main menu                */
       break;
       case 1:                         /* Hardware environment                */
            w_display_config(6,2);
       break;
       case 2:                         /* Date functions                      */
            date_functions();
       break;
       case 3:                         /* Time functions                      */
            time_functions();
       break;
       case 4:                         /* Network functions                   */
            network_functions();
       break;
    }
}   while(sel!=-1);                    /* w_setup close the misc menu before  */
if (misc_menu_ptr) m_close(&misc_menu_ptr);/*executes. Thus,the misc menu may */
}                                      /* already be closed.  So check it.    */
/*
Ŀ
 date_functions() - Demonstrate the various date functions                    

*/
void date_functions(void)
{
int      sel,                          /* Users choice - general or calendar  */
         num_days;                     /* # days when adding 147 hrs,... to tm*/
char     date_buffer[15];              /* Used to convert dates to strings    */
W_DATE   cur_date,                     /* Todays date                         */
         temp_date,                    /* Used to add\subtract from cur_date  */
         result_date;                  /* Result of adding\subtracting temp   */
WIN_PTR  window,                       /* Window to display date functions    */
         msg_window;
MEN_PTR  date_menu_ptr=0;
MEN_ITEM date_menu_items[2]={{0,0,"General ",".date_general",1},
                            {1,0,"Calendar",".date_calendar",1}};

sel=m_menu(10,45,2,8,w_color_menu,M_VERT,M_BORDER,w_shadows,M_CLOSE,2,0,
           &date_menu_ptr,date_menu_items);

switch (sel)
{
   case 0:
        d_curdate(&cur_date);          /* Get todays date                     */
        window=w_open(6,2,10,76,W_BORDER,w_shadows,w_color_data,"Date Functions");
        msg_window=msg_box("The C User Interface Library also has many date functions.");
        w_prtf(window,"\n Todays date............: %s        (excluding the century)\n",
               d_datestr(cur_date,date_buffer));
        w_prtf(window," Todays date............: %s      (including the century)\n",
               d_extdatestr(cur_date,date_buffer));
        w_prtf(window," Julian date............: %d\n",d_julian(cur_date));
        w_prtf(window," %d...................: ",cur_date.year);
        if (d_leapyear(cur_date.year))
            w_prtf(window,"is a leap year.\n");
        else
            w_prtf(window,"is not a leap year.\n");
        w_prtf(window," Month..................: %s\n",d_month(cur_date.month,date_buffer));
        w_prtf(window," Days in month..........: %d\n",d_inmonth(cur_date));
        d_ofweek(cur_date,date_buffer);
        w_prtf(window," Day of week............: %s\n",date_buffer);
        d_strextdate("00/47/00",&temp_date);
        d_add(cur_date,temp_date,&result_date);
        w_prtf(window," 47 days from today is..: %s\n",d_datestr(result_date,date_buffer));
        d_sub(cur_date,temp_date,&result_date);
        w_prtf(window," 47 days before today is: %s\n",d_datestr(result_date,date_buffer));
        k_wait(0);
        w_close(msg_window);
        w_close(window);
   break;
   case 1:
        d_calendar(6,10);
   break;
}
}
/*
Ŀ
 time_functions() - Demonstrate the various time functions                    

*/
void time_functions(void)
{
int      num_days;                     /*                                     */
char     time_buffer[15],              /* Used to convert times to strings    */
         date_buffer[15];              /* Used to convert dates to strings    */
WIN_PTR  msg_window,
         window;                       /* Display time function results here  */
W_TIME   cur_time,                     /* Current time                        */
         temp_time={147,12,30,' '},    /* Used to add\subtract from cur_time  */
         result_time;                  /* Result of adding\subtracting temp   */
W_DATE   cur_date,                     /* Todays date                         */
         temp_date={0,0,0},            /* Used to add\subtract from cur_date  */
         result_date;                  /* Result of adding\subtracting temp   */

d_curdate(&cur_date);
t_curtime(&cur_time);
window=w_open(6,2,6,76,W_BORDER,w_shadows,w_color_data,"Time Functions");
msg_window=msg_box("The C User Interface Library also has many time functions.");
w_prtf(window,"\n Current time...........: %s         (excluding the seconds)\n",
       t_timestr(cur_time,time_buffer));
w_prtf(window," Current time...........: %s      (including the seconds)\n",
       t_exttimestr(cur_time,time_buffer));
w_prtf(window," Current date...........: %s\n",
       d_datestr(cur_date,date_buffer));
num_days=t_add(cur_time,temp_time,&result_time);
temp_date.day=num_days;
d_add(cur_date,temp_date,&result_date);
w_prtf(window," 147 hrs, 12 min, and 30 sec from now is..: %s, %s\n",
       d_datestr(result_date,date_buffer),
       t_exttimestr(result_time,time_buffer));
num_days=t_sub(cur_time,temp_time,&result_time);
temp_date.day=num_days;
d_sub(cur_date,temp_date,&result_date);
w_prtf(window," 147 hrs, 12 min, and 30 sec before now is: %s, %s",
       d_datestr(result_date,date_buffer),
       t_exttimestr(result_time,time_buffer));
t_clock(15,52);
w_close(msg_window);
w_close(window);
}
/*
Ŀ
 network_functions() - Demonstrate the various Novell network functions       

*/
void network_functions(void)
{
int sel,                               /* Main menu selection                 */
    object_sel,                        /* Object menu selection               */
    prop_sel,                          /* Property menu selection             */
    value_sel;                         /* Value menu selection                */
N_BINDERY_OBJECT   object;             /* Holds Novell object information     */
N_BINDERY_PROPERTY property;           /* Holds object's property information */
N_BINDERY_VALUE    value;              /* Holds property's value information  */
WIN_PTR  object_win,                   /* Scrolling menu window for objects   */
         prop_win,                     /* Scrolling menu window for properties*/
         value_win;                    /* Scrolling menu window for values    */
unsigned int object_type[13]={N_USER,N_USER_GROUP,N_LOGGED_IN_USER,
         N_FILE_SERVER,N_JOB_SERVER,N_JOB_QUEUE,N_PRINT_SERVER,N_PRINT_QUEUE,
         N_ARCHIVE_SERVER,N_ARCHIVE_QUEUE,N_ADMINISTRATION,
         N_GATEWAY,N_REMOTE_BRIDGE};
char *titles[13]={"Users","User Groups","Logged in Users","File Servers",
                  "Job Servers","Job Queues","Print Servers","Print Queues",
                  "Archive Servers","Archive Queues","Administration","Gateways",
                  "Remote Bridges"};
MEN_PTR  network_menu_ptr=0;
MEN_ITEM network_menu_items[15]=
         {{0 ,0,"Users           ",".net_users"           ,1},
          {1 ,0,"User Groups     ",".net_user_groups"     ,1},
          {2 ,0,"Logged in Users ",".net_logged_in_users" ,1},
          {3 ,0,"File Servers    ",".net_file_servers"    ,1},
          {4 ,0,"Job Servers     ",".net_job_servers"     ,1},
          {5 ,0,"Job Queues      ",".net_job_queues"      ,1},
          {6 ,0,"Print Servers   ",".net_print_servers"   ,1},
          {7 ,0,"Print Queues    ",".net_print_queues"    ,1},
          {8 ,0,"Archive Servers ",".net_archive_servers" ,1},
          {9 ,0,"Archive Queues  ",".net_archive_queues"  ,1},
          {10,0,"Administration  ",".net_administration"  ,1},
          {11,0,"Gateways        ",".net_gateways"        ,1},
          {12,0,"Remote Bridges  ",".net_remote_bridges"  ,1},
          {13,0,"Netware         ",".net_netware"         ,1},
          {14,0,"Capture Settings",".net_capture_settings",1}};

do
{
   sel=m_menu(6,29,15,16,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,
              15,0,&network_menu_ptr,network_menu_items);
   switch (sel)
   {
      case -1:                         /* User pressed ESC                    */
      break;
      case 13:                         /* Display some info about Netware     */
           show_user();
      break;
      case 14:                         /* Display info on each parallel port  */
           show_capture();
      break;
      default:                         /* List of network objects, their prop-*/
           do                          /* erties, and their values            */
           {                           /* Display network objects             */
              object_sel=n_bindery_object_list(6,2,10,1,w_color_menu,
                &object_win,&object,object_type[sel],w_shadows,titles[sel],0);
              if (object_sel<0) {      /* If user pressed ESC or error        */
                 if (w_isopen(object_win)) w_close(object_win);
                 break;
              }
              do                       /* Display object's properties         */
              {
                 prop_sel=n_bindery_property_list(6,30,10,1,w_color_menu,
                          &prop_win,&property,object.name,n_int(object.type),
                          w_shadows,"Properties",0);
                 if (prop_sel<0) {     /* If user pressed ESC or error        */
                    if (w_isopen(prop_win)) w_close(prop_win);
                    break;
				 }					   /* Display property's values           */
                 value_sel=n_bindery_value_list(6,47,10,1,w_color_menu,
						   &value_win,&value,object.name,n_int(object.type),
                           property.name,w_shadows,"Values",0);
                 if (w_isopen(value_win)) w_close(value_win);
			  }  while(TRUE);
		   }  while(TRUE);
      break;
   }
}  while (sel!=-1);
m_close(&network_menu_ptr);
}
/*
Ŀ
 show_user() - Show some Novell information about the user.                   

*/
void show_user(void)
{
int     i;                             /* Loop variable                       */
WIN_PTR window;                        /* Window to show Novell user info     */
char   *present[2]={"Not installed","Installed"},
        volume[16],                    /* Current volume                      */
        rights;                        /* Effective rights                    */

window=w_open(6,2,15,60,W_BORDER,w_shadows,w_color_data,"Novell");
w_prtf(window,"\nNovell version..: %2X.%2.2X\n",
      (w_network.version & 0xFF00)>>8,
       w_network.version & 0x00FF);
w_prtf(window,"IPX.............: %s\n",present[w_network.installed]);
w_prtf(window,"SPX.............: %s\n",present[w_network.SPX]);
w_prtf(window,"TTS.............: %s\n",present[w_network.TTS]);
w_prtf(window,"Share...........: %s\n",present[w_network.SHARE]);
w_prtf(window,"Netbios.........: %s\n",present[w_network.NETBIOS]);
w_prtf(window,"Network node....: ");
for(i=0;i<6;++i)
    v_prtf("%2.2X",w_user.network_node[i]);
w_prtf(window,"\nConnection num..: %d\n",w_user.connection_number);
w_prtf(window,"Network number..: %ld\n",n_long(w_user.network_number));
w_prtf(window,"User............: %s\n",w_user.name);
w_prtf(window,"User ID.........: %8.8lX\n",n_long(w_user.object_id));
if (n_dir_get_volume(volume,N_CURRENT_DRIVE))
    w_prtf(window,"Volume..........: %s\n",volume);
else
    w_prtf(window,"Volume..........: Unknown\n");
w_prtf(window,"Current drive %c.: %s drive\n",f_getdisk()+'A',
       n_network_drive(N_CURRENT_DRIVE) ? "Network" : "Local");
if (n_dir_get_effective_rights(N_CURRENT_DRIVE,&rights))
    show_rights(window,rights);
else
    w_prtf(window,"Effective Rights: Unknown");
k_wait(0);
w_close(window);
}
/*
Ŀ
 show_rights() - Show directory rights                                        

*/
void show_rights(WIN_PTR window, char rights)
{
char rights_attr[8]={'R','W','O','C','D','P','S','M'};
int i,j;

w_prtf(window,"Effective Rights: ");
if (rights==0x00)
    w_prtf(window,"None\n");
else
{
   w_prtf(window,"[ ");
   j=1;
   for(i=0;i<8;++i)
   {
       if (j & rights)
           w_prtf(window,"%c ",rights_attr[i]);
       j+=j;
   }
   w_prtf(window,"]\n");
}
}
/*
Ŀ
 show_capture() - Show capture settings of all 3 parallel ports               

*/
void show_capture(void)                /* Info only valid on a network        */
{
WIN_PTR         window;                /* Capture settings window             */
N_PRINT_CONTROL capture;               /* Capture settings for eac parallel pt*/
char            i,                     /* Loop variable\parallel port         */
                old_cur_port,          /* Save current default port           */
                banner_name[13],       /* Banner user name                    */
                queue[47];             /* Print Queue names                   */

old_cur_port=w_printer.cur_port;

window=w_open(6,2,17,70,W_BORDER,w_shadows,w_color_data,"Capture settings");
if (!window) return;
w_prtf(window,"                LPT1              LPT2              LPT3\n");
w_prtf(window,"Captured......:\n");
w_prtf(window,"Print Queue...:\n");
w_prtf(window,"Status........:\n");
w_prtf(window,"Print flag....:\n");
w_prtf(window,"Tab size......:\n");
w_prtf(window,"Print Server..:\n");
w_prtf(window,"Number Copies.:\n");
w_prtf(window,"Form Type\\Name:\n");
w_prtf(window,"Banner Page...:\n");
w_prtf(window,"Local LPT.....:\n");
w_prtf(window,"Timeout.......:\n");
w_prtf(window,"Autoendcap....:\n");
w_prtf(window,"Lines per page:\n");
w_prtf(window,"Chars per line:\n");
w_prtf(window,"LPT  flag.....:\n");
w_prtf(window,"File flag.....:\n");
for(i=LPT1;i<=LPT3;++i)
{
    if (!n_capture_get(i,&capture))
    {
        w_errbox(0,"Error in getting capture status for LPT%d",i+1);
        continue;
    }
    w_setcur(window,1,16+i*18);
    p_set_port(i);                     /* Needed to test if capture active    */
    w_prtf(window,"%s\n",n_capture_active() ? "YES" : "NO");
    w_setcur(window,2,16+i*18);
    w_prtf(window,"%s\n",n_bindery_object_name(capture.print_queue_id,queue) ?
           queue : "Unknown");
    w_setcur(window,3,16+i*18);
    w_prtf(window,"%2.2X\n",n_capture_active() ? capture.status : p_code(w_printer.cur_port));
    w_setcur(window,4,16+i*18);
    w_prtf(window,"%2.2X\n",capture.print_flag);
    w_setcur(window,5,16+i*18);
    w_prtf(window,"%d\n",capture.tab_size);
    w_setcur(window,6,16+i*18);
    w_prtf(window,"%2.2X\n",capture.print_server);
    w_setcur(window,7,16+i*18);
    w_prtf(window,"%d\n",capture.num_copies);
    w_setcur(window,8,16+i*18);
    w_prtf(window,"%d - %s\n",capture.form_type,capture.form_name);
    w_setcur(window,9,16+i*18);
    if (n_capture_banner_get(banner_name))
        w_prtf(window,"%s-",banner_name);
    w_prtf(window,"%s\n",capture.banner);
    w_setcur(window,10,16+i*18);
    w_prtf(window,"%d\n",capture.local_lpt);
    w_setcur(window,11,16+i*18);
    if (capture.timeout_cntr)
        w_prtf(window,"%d\n",capture.timeout_cntr/18);
    else w_prtf(window,"DISABLED\n");
    w_setcur(window,12,16+i*18);
    w_prtf(window,"%s\n",capture.autoendcap ? "DISABLED" : "ENABLED");
    w_setcur(window,13,16+i*18);
    w_prtf(window,"%d\n",n_int(capture.lines_per_page));
    w_setcur(window,14,16+i*18);
    w_prtf(window,"%d\n",n_int(capture.chars_per_line));
    w_setcur(window,15,16+i*18);
    w_prtf(window,"%2.2X\n",capture.lpt_flag);
    w_setcur(window,16,16+i*18);
    w_prtf(window,"%2.2X\n",capture.file_flag);
}
k_wait(0);
w_close(window);
p_set_port(old_cur_port);              /* Restore current default port        */
}
/*
Ŀ
 Printer - Printer functions                                                  

*/
void printer(void)
{
static int first_time=TRUE;            /* Is this our 1st time calling printer*/
WIN_PTR window;
int      sel,                          /* Main printer menu selection         */
         sub_sel;                      /* Various printer sub-menu selections */
MEN_PTR  men_ptr=0;
MEN_ITEM men_items[7]={{0,0,"Quality    ",".quality"    ,1},
                       {1,0,"Font       ",".font"       ,1},
                       {2,0,"Style      ",".style"      ,1},
                       {3,0,"Color      ",".color"      ,1},
                       {4,0,"Height     ",".height"     ,1},
                       {5,0,"Width      ",".width"      ,1},
                       {6,0,"Orientation",".orientation",1}};
MEN_PTR  qual_men_ptr=0;
MEN_ITEM qual_men_items[2]={{0,0,"Draft ",".draft" ,1},
                            {1,0,"Letter",".letter",1}};
MEN_PTR  font_men_ptr=0;
MEN_ITEM font_men_items[10]={{0,0,"Roman     ",".roman"     ,1},
                            {1,0,"Sans Serif",".sans_serif",1},
                            {2,0,"Courier   ",".courier"   ,1},
                            {3,0,"Prestige  ",".prestige"  ,1},
                            {4,0,"Script    ",".script"    ,1},
                            {5,0,"Reserved  ",".reserved"  ,0},
                            {6,0,"Bold      ",".bold"      ,1},
                            {7,0,"Orator    ",".orator"    ,1},
                            {8,0,"Helvetica ",".helvetica" ,1},
                            {9,0,"Gothic    ",".gothic"    ,1}};
MEN_PTR  styl_men_ptr=0;
MEN_ITEM styl_men_items[8]={{0,0,"Emphasized  ",".emphasized"  ,1},
                            {1,0,"Underlined  ",".underlined"  ,1},
                            {2,0,"Italic      ",".italic"      ,1},
                            {3,0,"Subscript   ",".subscript"   ,1},
                            {4,0,"Superscript ",".superscript" ,1},
                            {5,0,"Condensed   ",".condensed"   ,1},
                            {6,0,"Expanded    ",".expanded"    ,1},
                            {7,0,"Proportional",".proportional",1}};
MEN_PTR  colr_men_ptr=0;
MEN_ITEM colr_men_items[8]={{0,0,"Black  ",".black"  ,1},
                            {1,0,"Magenta",".magenta",1},
                            {2,0,"Cyan   ",".cyan"   ,1},
                            {3,0,"Violet ",".violet" ,1},
                            {4,0,"Yellow ",".yellow" ,1},
                            {5,0,"Orange ",".orange" ,1},
                            {6,0,"Green  ",".green"  ,1},
                            {7,0,"Brown  ",".brown"  ,1}};
MEN_PTR  hght_men_ptr=0;
MEN_ITEM hght_men_items[3]={{0,0,"Normal Height",".normal_height",1},
                            {1,0,"Double Height",".double_height",1},
                            {2,0,"Quad   Height",".quad_height"  ,1}};
MEN_PTR  wdth_men_ptr=0;
MEN_ITEM wdth_men_items[3]={{0,0,"Normal Width",".normal_width",1},
                            {1,0,"Double Width",".double_width",1},
                            {2,0,"Quad   Width",".quad_width"  ,1}};
MEN_PTR  orientation_men_ptr=0;
MEN_ITEM orientation_men_items[2]={{0,0,"Portrait ",".portrait" ,1},
                                   {1,0,"Landscape",".landscape",1}};

if (first_time)
{
    window=msg_box("Use \"Setup\" to select your printer type and port.");
    if (!window) return;
    k_wait(0);
    w_close(window);
    first_time=FALSE;
}
window=p_start();                      /* Get printer ready and send emulation*/
if (!window) return;                   /* command if needed.                  */
w_close(window);                       /* On dot matrix printers,             */
if (strncmp(w_printer.model[w_printer.cur_port],".HP_Laser_II",12))
    p_char_set(P_SET_2);               /* Set character set to graphics for   */
                                       /* extended ascii (127-255) characters */

do
{
  sel=m_menu(6,66,7,11,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,7,0,&men_ptr,
             men_items);
  p_init();                            /* Reset printer to default settings   */
  switch (sel)
  {
     case 0:                           /* Print Quality                       */
          sub_sel=m_menu(8,60,2,6,w_color_menu,M_VERT,M_BORDER,w_shadows,M_CLOSE,2,0,
                         &qual_men_ptr,qual_men_items);
          if (sub_sel!=-1)
          {
              if (p_quality(sub_sel))
              {
                  p_prtf("%s Quality     - ",qual_men_items[sub_sel].text);
                  print_line();
              }
              else
                 w_errbox(0,"Unable to set print quality.");
          }
     break;
     case 1:                           /* Print Font                          */
          do
          {
             sub_sel=m_menu(9,56,10,10,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,
                            10,0,&font_men_ptr,font_men_items);
             if (sub_sel!=-1)
             {
                 if (p_font(sub_sel))
                 {
                     p_prtf("%s Font    - ",font_men_items[sub_sel].text);
                     print_line();
                 }
                 else
                    w_errbox(0,"Unable to select font.");
             }
          }  while(sub_sel!=-1);
          m_close(&font_men_ptr);
     break;
     case 2:                           /* Print Style                         */
          do
          {
             sub_sel=m_menu(10,56,8,12,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,
                            8,0,&styl_men_ptr,styl_men_items);
             if (sub_sel!=-1)
             {
                 switch (sub_sel)
                 {
                    case 0:
                         if (!p_style(P_EMPHASIZED,ON))
                             w_errbox(0,"Unable to set emphasized print style.");
                         else
                         {
                             p_prtf("%s Style - ",styl_men_items[sub_sel].text);
                             print_line();
                         }
                    break;
                    case 1:
                         if (!p_style(P_UNDERLINED,ON))
                             w_errbox(0,"Unable to set emphasized print style.");
                         else
                         {
                             p_prtf("%s Style - ",styl_men_items[sub_sel].text);
                             print_line();
                         }
                    break;
                    case 2:
                         if (!p_style(P_ITALIC,ON))
                             w_errbox(0,"Unable to set emphasized print style.");
                         else
                         {
                             p_prtf("%s Style - ",styl_men_items[sub_sel].text);
                             print_line();
                         }
                    break;
                    case 3:
                         if (!p_style(P_SUBSCRIPT,ON))
                             w_errbox(0,"Unable to set emphasized print style.");
                         else
                         {
                             p_prtf("%s Style - ",styl_men_items[sub_sel].text);
                             print_line();
                         }
                    break;
                    case 4:
                         if (!p_style(P_SUPERSCRIPT,ON))
                             w_errbox(0,"Unable to set emphasized print style.");
                         else
                         {
                             p_prtf("%s Style - ",styl_men_items[sub_sel].text);
                             print_line();
                         }
                    break;
                    case 5:
                         if (!p_style(P_CONDENSED,ON))
                             w_errbox(0,"Unable to set emphasized print style.");
                         else
                         {
                             p_prtf("%s Style - ",styl_men_items[sub_sel].text);
                             print_line();
                         }
                    break;
                    case 6:
                         if (!p_style(P_EXPANDED,ON))
                             w_errbox(0,"Unable to set emphasized print style.");
                         else
                         {
                             p_prtf("%s Style - ",styl_men_items[sub_sel].text);
                             print_line();
                         }
                    break;
                    case 7:
                         if (!p_style(P_PROPORTIONAL,ON))
                             w_errbox(0,"Unable to set emphasized print style.");
                         else
                         {
                             p_prtf("%s Style - ",styl_men_items[sub_sel].text);
                             print_line();
                         }
                    break;
                 }
             }
          } while (sub_sel!=-1);
          m_close(&styl_men_ptr);
     break;
     case 3:                           /* Color                               */
          do
          {
              sub_sel=m_menu(8,62,8,7,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,
                             8,0,&colr_men_ptr,colr_men_items);
              if (sub_sel!=-1)
              {
                  if (p_color(sub_sel))
                  {
                      p_prtf("%s            - ",colr_men_items[sub_sel].text);
                      print_line();
                  }
                  else
                     w_errbox(0,"Unable to select color.");
              }
         }    while (sub_sel!=-1);
         m_close(&colr_men_ptr);
     break;
     case 4:                           /* Heights                             */
          do
          {
              sub_sel=m_menu(12,56,3,13,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,
                             3,0,&hght_men_ptr,hght_men_items);
              switch (sub_sel)
              {
                 case 0:               /* Single Height                       */
                      if (p_height(P_SINGLE_HEIGHT))
                      {
                          p_prtf("%s - ",hght_men_items[0].text);
                          print_line();
                      }
                      else
                         w_errbox(0,"Unable to set single height.");
                 break;
                 case 1:               /* Double Height                       */
                      if (p_height(P_DOUBLE_HEIGHT))
                      {
                          p_prtf("%s - ",hght_men_items[1].text);
                          print_line();
                      }
                      else
                         w_errbox(0,"Unable to set double height.");
                 break;
                 case 2:               /* Quad   Height                       */
                      if (p_height(P_QUAD_HEIGHT))
                      {
                          p_prtf("%s - ",hght_men_items[2].text);
                          print_line();
                      }
                      else
                         w_errbox(0,"Unable to set quad height.");
                 break;
              }
          }    while (sub_sel!=-1);
          m_close(&hght_men_ptr);
     break;
     case 5:                           /* Widths                              */
          do
          {
              sub_sel=m_menu(12,56,3,13,w_color_menu,M_VERT,M_BORDER,w_shadows,M_OPEN,
                             3,0,&wdth_men_ptr,wdth_men_items);
              switch (sub_sel)
              {
                 case 0:               /* Single Width                        */
                      if (p_width(P_SINGLE_WIDTH))
                      {
                          p_prtf("%s - ",wdth_men_items[0].text);
                          print_line();
                      }
                      else
                         w_errbox(0,"Unable to set single width.");
                 break;
                 case 1:               /* Double Width                        */
                      if (p_width(P_DOUBLE_WIDTH))
                      {
                          p_prtf("%s - ",wdth_men_items[1].text);
                          print_line();
                      }
                      else
                         w_errbox(0,"Unable to set double width.");
                 break;
                 case 2:               /* Quad   Width                        */
                      if (p_width(P_QUAD_WIDTH))
                      {
                          p_prtf("%s - ",wdth_men_items[2].text);
                          print_line();
                      }
                      else
                         w_errbox(0,"Unable to set quad width.");
                 break;
              }
          }    while (sub_sel!=-1);
          m_close(&wdth_men_ptr);
     break;
     case 6:                           /* Orientation                         */
          sub_sel=m_menu(13,59,2,9,w_color_menu,M_VERT,M_BORDER,w_shadows,M_CLOSE,2,0,
                         &orientation_men_ptr,orientation_men_items);
          if (sub_sel!=-1)
          {
              if (p_orientation(sub_sel))
              {
                  p_prtf("%s Orientation - ",orientation_men_items[sub_sel].text);
                  print_line();
              }
              else
                 w_errbox(0,"Unable to set orientation.");
          }
     break;
  }
} while (sel!=-1);
p_end(window);                         /* All printing is bracketed by the 2  */
m_close(&men_ptr);                     /* functions, p_start() and p_end().   */
}                                      /* See printing chapter for details    */
/*
Ŀ
 print_line() - Print sample text                                             

*/
void print_line(void)
{
p_prtf("%s","C User Interface Library - Version 1.0\n");
}
/*
Ŀ
 files                                                                        

*/
void files(void)
{
static  char file[126]={""};           /* File selected to edit               */
FILE   *handle;                        /* File handle                         */
WIN_PTR msg_window;                    /* Help message                        */

msg_window=msg_box("Enter the name of a \".c\" file you want to edit, or just press enter.");
handle=f_fileio(6,file,'r','t',10,34,5,3,"*.c",FA_ARCH,".file_input");
w_close(msg_window);
if (handle)
{
    fclose(handle);
    f_edit(6,2,w_max_rows-10,76,90,file,w_color_editor_text,
           w_color_editor_block,EDIT,w_shadows,TRUE,file,".f_edit");
}
}
/*
Ŀ
 msg_box() - Display a line message at the bottom of the screen               

*/
WIN_PTR msg_box(char *msg)
{
WIN_PTR window;
int     old_color,
        len;

old_color=v_getcolor();
v_setcolor(w_color_help.enhanced);
len=strlen(msg);
window=w_open(w_max_rows-3,2,1,w_max_cols-4,1,0,w_color_help,0);
if (window)
{
    w_setcur(window,0,(w_max_cols-4-len)/2);
    w_prtf(window,"%s",msg);
}
v_setcolor(old_color);
return(window);
}
